## lie 2.2.2%2Bdfsg

=== box/Makefile ===
CINCLUDES= -I. -I..

.SUFFIXES:

%.o: %.c
	$(CC) -c $(CPPFLAGS) $(all-C-flags) $<

objects=\
 altdom.o branch.o centr.o closure.o contragr.o coxeter.o decomp.o defs.o\
 diagram.o domchar.o factor.o grpdata.o lr.o matrix.o orbit.o\
 plethysm.o sorting.o static3.o symg.o tensor.o weyl.o weylloop.o

.PHONY: all clean

all:	.last_compiled

.last_compiled:	$(objects)
	touch .last_compiled

defs.o:		defs.h
# standard targets

clean:
	rm -f *~ *.o .last_compiled

## lie 2.2.2+dfsg

=== Makefile ===
srcdir     :=$(shell pwd)

CFLAGS= -O
fixed-flags = -I$(srcdir) -I$(srcdir)/box
all-C-flags:= -ansi $(fixed-flags) $(CFLAGS)
non-ansi-flags :=  $(fixed-flags) $(CFLAGS)

CC = gcc # some compiler for ANSI/ISO C

# These settings should also be used in subdirectories:
export CC all-C-flags fixed-flags CFLAGS

.SUFFIXES:

%.o: %.c
	$(CC) -c $(CPPFLAGS) $(all-C-flags) $<

common_objects=lexer.o parser.o\
 non-ANSI.o bigint.o binmat.o creatop.o gettype.o getvalue.o\
 init.o learn.o main.o mem.o node.o onoff.o output.o poly.o sym.o

objects=$(common_objects) print.o getl.o
GAP_objects=$(common_objects) gapprint.o gapgetl.o

# Global organisation (phony targets)

.PHONY: install all script finish no_readline
.PHONY:	math_functions binding_functions

# The first target makes everything to get an operational LiE program
install: all script INFO.a

# To 'make all', we first descend into the subdirectories, and afterwards
# return to finish here.

all:
	$(MAKE) math_functions binding_functions
	$(MAKE) finish

finish: Lie.exe LEARN.ind INFO.ind # do not call 'make finish' directly

math_functions:
	$(MAKE) -C box all

binding_functions:
	$(MAKE) -C static


# Real dependencies 

# The file non-ANSI.c should be compiled without -ansi flag

non-ANSI.o: non-ANSI.c
	$(CC) -c $(CPPFLAGS) $(non-ansi-flags) $<


# These object files depend on the data types declared in those .h files:

gettype.o getvalue.o init.o main.o mem.o node.o sym.o: memtype.h nodetype.h


# The parser is generated by bison (BSD-yacc will NOT do) and in compilation
# requires inclusion of parseaux.c (derived from parseaux.w).

parser.c parser.h: parser.y
	bison -d --output-file=parser.c parser.y
parser.o: parser.c parser.h parseaux.c

lexer.o: parser.h

# Binding to the GNU readline library is achieved by -Dpreprocessor below

getl.o:	getl.c
	$(CC) -c $(CPPFLAGS) -Dpreprocessor $(all-C-flags) $<
gapgetl.o: getl.c
	$(CC) -c $(CPPFLAGS) $(all-C-flags) -o gapgetl.o $<

# Though date.c never changes, it should be recompiled for each modifiaction.
# Since Liegap is a separate executable, it gets its own version of the date.
# Since global recompilation should be issued by 'make all' rather than by
# 'make Lie.exe', we may assume here that the '.last_compiled' dates have just
# been set to the most recent one of object files in the respective
# subdirectories, whence taking that dummy file as dependency suffices.

date.o: date.c $(objects) box/.last_compiled static/.last_compiled
	$(CC) -ansi -c date.c
gapdate.o: date.c $(GAP_objects) box/.last_compiled static/.last_compiled
	$(CC) -ansi -c -o gapdate.o date.c

Lie.exe: date.o
	$(CC) -o Lie.exe $(objects) date.o static/*.o box/*.o -lreadline
	chmod g+w Lie.exe
Liegap.exe: gapdate.o
	$(CC) -o Liegap.exe $(GAP_objects) gapdate.o static/*.o box/*.o
	chmod g+w Liegap.exe

noreadline: math_functions binding_functions $(common_objects) print.o
	$(CC) -c $(CPPFLAGS) $(all-C-flags) getl.c
	$(MAKE) date.o
	$(CC) -o Lie.exe $(objects) date.o static/*.o box/*.o
	chmod g+w Lie.exe
	$(MAKE) LEARN.ind INFO.ind script INFO.a

script:
	./make_lie

INFO.ind:	INFO.0 INFO.1 INFO.2 INFO.3 INFO.4 infoind
	./infoind

LEARN.ind:	LEARN learnind
	./learnind

infoind: util/infoind.c
	$(MAKE) -C util ../infoind
learnind: util/learnind.c
	$(MAKE) -C util ../learnind

INFO.a: progs/maxsub progs/maxsub0 progs/eqrank
	rm -f INFO.a
	./Lie.exe < progs/maxsub

.PHONY: clean
clean:
	$(MAKE) -C box clean
	$(MAKE) -C static clean
	rm -f *~ *.o parser.[ch] INFO.a LEARN.ind
	rm -f Lie.exe Liegap.exe infoind learnind util/*.o

=== static/Makefile ===
c_sources=static1.c static2.c static4.c static5.c static6.c static7.c

.SUFFIXES:

%.o: %.c
	$(CC) -c $(CPPFLAGS) $(all-C-flags) $<

.last_compiled:	$(c_sources:.c=.o)
	touch .last_compiled

all:	.last_compiled

# TAGS file with identifier definitions for emacs perusal.

TAGS:	$(c_sources)
	etags $(c_sources)

# standard targets

clean:
	rm -f *.o .last_compiled

=== util/Makefile ===
CINCLUDES=-I.. -I../box

.SUFFIXES:

%.o: %.c
	$(CC) -c $(CPPFLAGS) $(all-C-flags) $<

all: 	../infoind ../learnind

../learnind: learnind.o
	$(CC) -o ../learnind learnind.o

../infoind: infoind.o
	$(CC) -o ../infoind infoind.o

=== debian/changelog ===
lie (2.2.2+dfsg-3build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:50:54 +1100

lie (2.2.2+dfsg-3build2) noble; urgency=medium

  * No-change rebuild for readline time64 change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 02:56:46 +0100

lie (2.2.2+dfsg-3build1) disco; urgency=medium

  * No-change rebuild for readline soname change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 14 Jan 2019 20:01:33 +0000

lie (2.2.2+dfsg-3) unstable; urgency=medium

  * Bump debhelper version to 11.
  * Bump standards version to 4.1.3.
  * debian/rules: renewed.
  * debian/clean: added.
  * debian/lie.1: removed manual.dvi reference. (Closes: #659502)
  * Update my name.
  * Thanks Adam Borowski for fixing parallel builds.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Thu, 11 Jan 2018 16:03:34 +0100

lie (2.2.2+dfsg-2) unstable; urgency=low

  [ Gürkan Sengün ]
  * Update my email address. (Closes: #675216)
  * Added debian/source/format, switch to format 3.0 (quilt)
  * Fix lintian-warning debian-rules-missing-recommended-target
  * Bump standards version to 3.9.3, switch to format 3.0 (quilt)
  * Bump debhelper version to 8.
  
  [ Axel Beckert ]
  * Add -j1 to prevent FTBFS on parallel builds
  * Fix lintian warning copyright-refers-to-symlink-license

 -- Gürkan Sengün <gurkan@phys.ethz.ch>  Thu, 31 May 2012 12:44:44 +0200

lie (2.2.2+dfsg-1.2) unstable; urgency=low

  * Non-maintainer upload.
  * Do not link against ncurses (Closes: #646147).

 -- Sven Joachim <svenjoac@gmx.de>  Sun, 30 Oct 2011 21:44:13 +0100

lie (2.2.2+dfsg-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Switch from libreadline5-dev to libreadline-dev. (Closes: #553802) 

 -- Ana Beatriz Guerrero Lopez <ana@debian.org>  Wed, 10 Aug 2011 22:00:16 +0200

lie (2.2.2+dfsg-1) unstable; urgency=low

  * Initial release. (Closes: #402226)
  * Manual pages added.
  * Set default editor and pager to Debian conventions.
  * Modified "lie" startup script to allow for installation in
    arbitrary locations.
  * Added -lncurses to the link command; -lreadline is not enough.
  * Removed manual/manual.dvi.

 -- Kasper Peeters <kasper.peeters@aei.mpg.de>  Sun, 29 Apr 2006 19:07:13 +0100

=== debian/control ===
Source: lie
Section: math
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Gürkan Myczko <gurkan@phys.ethz.ch>
Uploaders: Kasper Peeters <kasper.peeters@aei.mpg.de>
Build-Depends: debhelper (>= 11), libreadline-dev, bison, dh-exec
Standards-Version: 4.1.3
Homepage: http://young.sp2mi.univ-poitiers.fr/~marc/LiE/

Package: lie
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Computer algebra package for Lie group computations
 LiE is a computer algebra system that is specialised in computations
 involving (reductive) Lie groups and their representations.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --max-parallel 1
